package hexagon.world;

import java.util.TreeMap;

public class BlockColumn {
	
	protected TreeMap<Integer, Block> blocks;
	protected Chunk chunk;
	
	public BlockColumn(Chunk chunk) {
		this.chunk = chunk;
		blocks = new TreeMap<>();
	}
	
	public Block getBlock(int y) {
		return blocks.get(y);
	}
	
	public void setBlock(Block block, int y) {
		Block prev = blocks.put(y, block);
		if (prev != null) prev.onRemove();
		chunk.world.addBlockToUpdateList(block);
	}
	
	public void removeBlock(int y) {
		Block prev = blocks.remove(y);
		prev.onRemove();
	}
	
	public void onRemove() {
		for (Block b : blocks.values())
			b.onRemove();
		blocks.clear();
	}
	
}
