package hexagon.model;

import org.lwjgl.util.vector.Vector2f;

import hexagon.world.World;

public class HexagonModel extends TexturedModel {
	
	public static final Vector2f[] points = new Vector2f[6];
	public static final float x60, y60;
	
	public static float[] vertices = new float[3 * 6];
	public static float[] texCoords = new float[2 * 6];
	public static int[] indices = new int[3 * 4];
	
	public static HexagonModel theModel;
	
	static {
		for (int i = 0; i < 6; i++) {
			points[i] = new Vector2f((float) Math.cos(Math.PI * (i / 3d)), (float) Math.sin(Math.PI * (i / 3d)));
		}
		x60 = points[1].x;
		y60 = points[1].y;
	}
	
	public static void init() {
		theModel = new HexagonModel(Loader.theLoader.loadTexture("test"));
	}
	
	public HexagonModel(int texID) {
		super(createRawModel(), texID);
	}
	
	private static RawModel createRawModel() {
		for (int i = 0; i < 6; i++) {
			double v = i % 3 == 0 ? 0 : (i > 3 ? -1 : 1) * World.angleHalfHexagon;
			vertices[3 * i] = points[i].x;
			vertices[3 * i + 1] = (float) ((Math.cos(v) - 1) * World.radius);
			vertices[3 * i + 2] = (float) (Math.sin(v) * World.radius);
		}
		
		for (int i = 0; i < 4; i++) {
			indices[3 * i] = 0;
			indices[3 * i + 1] = i + 1;
			indices[3 * i + 2] = i + 2;
		}
		
		for (int i = 0; i < 6; i++) {
			texCoords[2 * i] = points[i].x;
			texCoords[2 * i + 1] = points[i].y;
		}
		
		return Loader.theLoader.loadToVAO(vertices, texCoords, indices);
	}
	
	
}
